#pragma once
#include <functional>
#include <map>
#include <mutex>
#include "runable.h"

class Synchronization : public Runable {
public:
	virtual void run();
};

class Workgroup {
private:
    int sigma;
    int iterationsPerThreads;
    bool synchronized;
    std::mutex sync;
    std::map<bool, std::function<void(void)>> workers;

public:
	Workgroup();

    int getSigma();
    int getIterationsPerThread();
    void setIterationsPerThread(int value);
    bool getIsSynchronized();
    void setIsSynchronized(bool value);
    void doWork();
};